BlessingBar = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceConsole-2.0")
BlessingBar:RegisterChatCommand("/BlessingBar", nil)
BBSpellCache = {}

local Spammed = false

-- COUNT TOTAL ENTRIES IN A TABLE
local function countEntries(tbl)
    local cnt = 0;
    for k in pairs(tbl) do cnt = cnt + 1; end
    return cnt
end

-- RETURN CLASS
local function ClassCheck()
    local _, class = UnitClass("player")
    if class == "PALADIN" then return true else return false end
end

-- FIND HIGHEST SPELL RANK
local function GetSpellID(spell, rank)
	local i = 1
	local spellID
	local highestRank
	while true do
		local spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL)
		if (not spellName) then
			break
		end
		if (spellName == spell) then
			if (rank) then
				if (spellRank == rank) then
					return i
				end
			else
				spellID = i
				highestRank = spellRank
			end
		end
		i = i + 1
		if (i > 250) then
			break
		end
	end			
	return spellID, highestRank
end

function BlessingBar:OnEnable()    
    if ClassCheck() then
        self:RegisterEvent("SPELL_UPDATE_COOLDOWN")
        self:RegisterEvent("BAG_UPDATE")
        self:RegisterEvent("CHARACTER_POINTS_CHANGED")
    
        BlessingBarLoad()
    end
end

function BlessingBar:CHARACTER_POINTS_CHANGED()
    if not Spammed then
        Spammed = true
        DEFAULT_CHAT_FRAME:AddMessage("|cffffff00 "..BlessingBarNotice[1])
        DEFAULT_CHAT_FRAME:AddMessage(" "..BlessingBarNotice[2])
    end
end

function BlessingBarUpdate()
    -- thanks to ckknight & navcaririel for the line below!
    local num = tonumber((this:GetName()):match("%d+"))
    local usable, nomana = IsUsableSpell(BlessingBarSpells[num])
    local button = "BlessingBarButton"

    if not getglobal(button..num).texture then return end
    
    -- CHANGE TO BLUE IF INSUFFICIENT MANA
    if nomana then
        getglobal(button..num).texture:SetVertexColor(.1, .3, 1)
    
    -- CHANGE TO RED IF OUT OF RANGE
    elseif IsSpellInRange(BlessingBarSpells[num], "target") == 0 then
        getglobal(button..num).texture:SetVertexColor(0.8, 0.1, 0.1)
    
    -- GREY OUT IF FLYING/DEAD/GHOST
    elseif UnitIsDeadOrGhost("player") or UnitOnTaxi("player") then
        getglobal(button..num).texture:SetVertexColor(.3, .3, .3)
    
    -- CLEAR
    else
        getglobal(button..num).texture:SetVertexColor(1, 1, 1)
    end
end

function BlessingBarLoad()
    local width, height, scale = 60, 60, .636
    local BlessingBarLastButton = "MultiBarLeftButton1"
    
    BlessingBarButton1 = CreateFrame("Button", "BlessingBarButton1", UIParent, "BlessingBarButtonTemplate")
    BlessingBarButton2 = CreateFrame("Button", "BlessingBarButton2", UIParent, "BlessingBarButtonTemplate")
    BlessingBarButton3 = CreateFrame("Button", "BlessingBarButton3", UIParent, "BlessingBarButtonTemplate")
    BlessingBarButton4 = CreateFrame("Button", "BlessingBarButton4", UIParent, "BlessingBarButtonTemplate")
    BlessingBarButton5 = CreateFrame("Button", "BlessingBarButton5", UIParent, "BlessingBarButtonTemplate")
    BlessingBarButton6 = CreateFrame("Button", "BlessingBarButton6", UIParent, "BlessingBarButtonTemplate")
    BlessingBarButton7 = CreateFrame("Button", "BlessingBarButton7", UIParent, "BlessingBarButtonTemplate")
    BlessingBarButton8 = CreateFrame("Button", "BlessingBarButton8", UIParent, "BlessingBarButtonTemplate")
    BlessingBarButton9 = CreateFrame("Button", "BlessingBarButton9", UIParent, "BlessingBarButtonTemplate")
    BlessingBarButton10 = CreateFrame("Button", "BlessingBarButton10", UIParent, "BlessingBarButtonTemplate")
    BlessingBarButton11 = CreateFrame("Button", "BlessingBarButton11", UIParent, "BlessingBarButtonTemplate")
    BlessingBarButton12 = CreateFrame("Button", "BlessingBarButton12", UIParent, "BlessingBarButtonTemplate")
    BlessingBarButton13 = CreateFrame("Button", "BlessingBarButton13", UIParent, "BlessingBarButtonTemplate")
    BlessingBarButton14 = CreateFrame("Button", "BlessingBarButton14", UIParent, "BlessingBarButtonTemplate")
    BlessingBarButton15 = CreateFrame("Button", "BlessingBarButton15", UIParent, "BlessingBarButtonTemplate")

    BlessingBarButton10Text = BlessingBarButton10:CreateFontString(nil, "BACKGROUND")
    BlessingBarButton11Text = BlessingBarButton11:CreateFontString(nil, "BACKGROUND")
    BlessingBarButton12Text = BlessingBarButton12:CreateFontString(nil, "BACKGROUND")
    BlessingBarButton13Text = BlessingBarButton13:CreateFontString(nil, "BACKGROUND")
    BlessingBarButton14Text = BlessingBarButton14:CreateFontString(nil, "BACKGROUND")
    BlessingBarButton15Text = BlessingBarButton15:CreateFontString(nil, "BACKGROUND")

    for i = 10, 15 do
        local text = getglobal("BlessingBarButton"..i.."Text")
        text:SetFontObject(GameFontNormalHuge)
        local font, size = text:GetFont()
        text:SetFont(font, size, "OUTLINE")
        text:SetWidth(100); text:SetHeight(40)
        text:SetPoint("BOTTOMLEFT", "BlessingBarButton"..i, "BOTTOMLEFT", -15, -5)
        text:SetJustifyH("MIDDLE"); text:SetJustifyV("MIDDLE")
        text:SetParent("BlessingBarButton"..i)
    end
        
    for i = 1, countEntries(BlessingBarSpells) do
        local button = getglobal("BlessingBarButton"..i)
        if GetSpellID(BlessingBarSpells[i]) then
            button:SetWidth(width); button:SetHeight(height); button:SetScale(scale); button:EnableMouse(true)
            
            if (i == 1) then
                button:SetPoint("CENTER", MultiBarLeftButton1, "CENTER", -68, -1)
            elseif (BlessingBarLastButton == "MultiBarLeftButton1") then
                button:SetPoint("CENTER", MultiBarLeftButton1, "CENTER", -68, -1)
            elseif (i == 10) then
                button:SetPoint("CENTER", BlessingBarButton1, "CENTER", -68, -1)
            else
                button:SetPoint("CENTER", BlessingBarLastButton, "BOTTOM", 0, -36)
            end
            
            button:SetAttribute("type", "spell")
            --button:SetAttribute("modifiers", "SELFCAST:self")
            --button:SetAttribute("self-unit", "player")
            button:SetAttribute("spell", BlessingBarSpells[i])

            button:SetScript("OnLeave", function() GameTooltip:Hide() end)
            button:SetScript("OnEnter", function()
                GameTooltip:SetOwner(this, "ANCHOR_CURSOR")
                GameTooltip:SetSpell(GetSpellID(BlessingBarSpells[i]))
                GameTooltip:Show()
            end)

            local t = button:CreateTexture(nil,"BACKGROUND")
                t:SetTexture(GetSpellTexture(BlessingBarSpells[i]))
                t:SetAllPoints(button)
                button.texture = t
            
            BlessingBarLastButton = button
        else
            button:Hide()
        end
    end
    
    BlessingBarCount()
end

-- UPDATE COUNT WHEN BAGS CHANGE
function BlessingBar:BAG_UPDATE()
    BlessingBarCount()
end

-- DISPLAY CONSUMABLE ITEM COUNTS
function BlessingBarCount()
    if not ClassCheck() then return end
    
    local Items = GetItemCount(21177)
    
    for i = 10, 15 do
        getglobal("BlessingBarButton"..i.."Text"):SetText("|cffffffff"..Items)
    end
end

-- UPDATE COOLDOWN
function BlessingBar:SPELL_UPDATE_COOLDOWN()
    if ClassCheck() then
        for i = 1, countEntries(BlessingBarSpells) do
            if (GetSpellCooldown(BlessingBarSpells[i]) ~= nil and GetSpellCooldown(BlessingBarSpells[i]) > 0) then
                local start, duration, enable = GetSpellCooldown(BlessingBarSpells[i])
                getglobal("BlessingBarButton".. i .."Cooldown"):SetCooldown(start, duration)
            end
        end
    end
end